﻿<?xml version="1.0" encoding="UTF-8"?>
<!--
******************************************************************************************************************

		OIOUBL Instance Documentation	

		title= OIOUBL_Invoice.xml	
		replaces= invoice.xml	
		publisher= "IT og Telestyrelsen"
		Creator= Finn Christensen and Charlotte Dahl Skovhus
		created= 2006-12-29
		modified= 2007-02-03
		modified-by=Bryan Rasmussen
		issued= 2006-12-29
		conformsTo= UBL-Invoice-2.0.xsd
		description= "Stylesheet for displaying a OIOUBL-2.0 Invoice"
		rights= "It can be used following the Common Creative Licence"
		
		all terms derived from http://dublincore.org/documents/dcmi-terms/

		For more information, see www.oioubl.dk	or email oioubl@itst.dk
		
******************************************************************************************************************
-->
<xsl:stylesheet version="1.0" 

        xmlns:xsl  = "http://www.w3.org/1999/XSL/Transform" 
        xmlns:n1   = "urn:oasis:names:specification:ubl:schema:xsd:Invoice-2" 
        xmlns:cac  = "urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2" 
        xmlns:cbc  = "urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2" 
        xmlns:ccts = "urn:oasis:names:specification:ubl:schema:xsd:CoreComponentParameters-2" 
        xmlns:sdt  = "urn:oasis:names:specification:ubl:schema:xsd:SpecializedDatatypes-2" 
        xmlns:udt  = "urn:un:unece:uncefact:data:specification:UnqualifiedDataTypesSchemaModule:2"
                                      exclude-result-prefixes="n1 cac cbc ccts sdt udt">


	<xsl:include href="CommonTemplates.xsl"/>
	<xsl:output method="xml" omit-xml-declaration="yes"/>
<!--what was the reason to strip spaces? I have gone ahead and removed it. -->
	<!--<xsl:strip-space elements="*"/>-->

<xsl:template match="/">
<html>
<head>
<xsl:call-template name="buildhtmlhead"/>
</head>
<body class="oiodatabody oioubl">
<div class="logo">
							<img class="defaultlogo" src="../images/GTADefaultlogo.jpg" width="100%" alt="Logo"/></div>
<xsl:apply-templates/>


</body>
</html>
</xsl:template>

<xsl:template name="buildhtmlhead">
<title><xsl:value-of select="'Invoice'"/></title>
<link rel="Stylesheet" type="text/css" href="OIOUBL.css"></link>
</xsl:template>


<xsl:template match="n1:Invoice">
<div class="header">
<h3>
								<xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='OIOUBLInv']"/>&#160; 
								<xsl:if test="cbc:InvoiceTypeCode = 'Proforma' or cbc:InvoiceTypeCode = 'Factored'">-&#160;<xsl:value-of select="cbc:InvoiceTypeCode"/></xsl:if>&#160;
								<xsl:if test="cbc:CopyIndicator ='true'"><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='CopyIndicator']"/></xsl:if>
							</h3>

</div>
<div class="content">
<p class="headerinfo" id="AccountingSupplierInv"><span class="label"><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='AccountingSupplierInv']"/></span> <span class="value">
<xsl:apply-templates select="cac:AccountingSupplierParty"/></span></p>
<p class="headerinfo">
<!--comment 1-->
							<xsl:if test="cac:AccountingSupplierParty/cac:Party/cac:Contact !=''">
								<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='Contact']"/></b>
								<br/>
								<xsl:apply-templates select="cac:AccountingSupplierParty/cac:Party" mode="accsupcontact"/>
							</xsl:if>
</p>
<p class="headerinfo"><span class="label"><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='SellerParty']"/></span>
								<br/>

								<xsl:apply-templates select="cac:SellerSupplierParty"/>
</p>


</div>
<xsl:call-template name="documentlines"/>
<xsl:call-template name="additionalmonetaryinformation"/>
			<!-- Start på betalingsoplysninger -->
<xsl:call-template name="betalingoplysninger"/>
<xsl:call-template name="footer"/>
</xsl:template>

<xsl:template name="documentlines">
<div class="documentlines">
<table border="0" width="100%" cellspacing="0" cellpadding="2">
					<tr class="UBLInvoiceLineHeader">
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='LineID']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='SellersItemIdentification']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='ItemName']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='Quantity']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='QuantityUnitCode']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='PriceUnit']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='TaxScheme']"/></b>
						</td>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='AllowanceChargePrice']"/></b>
						</td>
						<td align="right">
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='LineExtensionAmountLine']"/></b>
						</td>
					</tr>
					<xsl:apply-templates select="cac:InvoiceLine"/>
				</table>
</div>
</xsl:template>
<xsl:template name="additionalmonetaryinformation">
		<!--Start afgifter og totaler-->
				<table border="0" width="100%" cellspacing="0" cellpadding="2">
					<tr>
						<td colspan="8">
							<hr size="2"/>
						</td>
					</tr>
						<!-- Linjesum -->
						<xsl:apply-templates select="cac:LegalMonetaryTotal" mode="LineTotal"/>
						<!-- Afgifter på header -->
						<xsl:apply-templates select="cac:TaxTotal" mode="afgift"/>
						<!-- Rabat og gebyr på header -->
						<xsl:apply-templates select="cac:AllowanceCharge" mode="total"/>
						<!-- Moms  -->
						<xsl:apply-templates select="cac:TaxTotal" mode="moms"/>
						<!-- Fakturatotal  -->
						<xsl:apply-templates select="cac:LegalMonetaryTotal" mode="Total"/>
					<tr>
						<td colspan="8">
							<hr size="5"/>
						</td>
					</tr>
				</table>
				<!--Slut afgifter og totaler-->
				
	
				
</xsl:template>
<xsl:template name="betalingoplysninger">
<div class="betalingoplysninger">
<div class="paymentmeans"><xsl:apply-templates select="cac:PaymentMeans"/></div>
<div class="paymentterms"><xsl:apply-templates select="cac:PaymentTerms"/></div>
<div class="otherpaymentinfo"><xsl:apply-templates mode="examplemode1"/></div>
</div>
</xsl:template>
<xsl:template match="*" mode="examplemode1"/>

<xsl:template match="cac:TaxExchangeRate[.!=''] | cac:PricingExchangeRate [.!=''] | cac:PaymentExchangeRate [.!='']|cac:PaymentAlternativeExchangeRate [.!='']| cac:PrepaidPayment [.!=''] |cac:LegalMonetaryTotal [.!='']| cac:AllowanceCharge [.!=''] | cac:TaxTotal [.!='']">
<xsl:variable name="localname" select="local-name()"/>
								<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name=$localname]"/></b><br/>
<p>								<xsl:apply-templates select="self::*"/>
</p>							
</xsl:template>

<xsl:template name="footer">
<xsl:if test="cac:InvoicePeriod !='' or cbc:Note !='' or cac:OrderReference/cac:DocumentReference !='' or cac:ContractDocumentReference/cbc:ID !='' or cac:AdditionalDocumentReference/cbc:ID !=''">
				<table border="0" width="100%" cellspacing="0" cellpadding="2">
					<tr>
						<td colspan="3">
							<hr size="2"/>
						</td>
					</tr>
					<tr>
						<td>
						<xsl:if test="cac:InvoicePeriod !=''">
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='InvoicePeriod']"/></b>&#160;<xsl:apply-templates select="cac:InvoicePeriod"/><br/>
						</xsl:if>
						<xsl:if test="cbc:Note[.!='']">
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='Notes']"/></b>&#160;<xsl:apply-templates select="cbc:Note"/><br/>
						</xsl:if>
						<xsl:if test="cac:OrderReference/cac:DocumentReference !=''">
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='OrderDocumentReference']"/></b>&#160;<xsl:apply-templates select="cac:OrderReference" mode="reference"/><br/>
						</xsl:if>
						<xsl:if test="cac:ContractDocumentReference/cbc:ID !=''">
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='ContractDocumentReference']"/></b>&#160;<xsl:apply-templates select="cac:ContractDocumentReference"/><br/>
						</xsl:if>
						<xsl:if test="cac:AdditionalDocumentReference/cbc:ID !=''">
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='AdditionalDocumentReferenceID']"/></b>&#160;<xsl:apply-templates select="cac:AdditionalDocumentReference"/><br/>
						</xsl:if>
						</td>
					</tr>
				</table>
				</xsl:if>
				<!-- Slut på fritekst og referencer-->
				
				<!-- Start på OIOUBL footer -->
				<table border="0" width="100%" cellspacing="0" cellpadding="2">
					<tr>
						<td colspan="3">
							<hr size="2"/>
						</td>
					</tr>
					<tr>
						<td>
							<b><xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name='OIOUBLDoc']"/></b>
							<br/>
                                 <xsl:apply-templates mode="globalvaluepairs"/>
						
							
							
						</td>
						<xsl:if test="cac:Signature !=''">
							<td>
								<xsl:apply-templates select="cac:Signature"/>
							</td>
						</xsl:if>
					</tr>
				</table>
</xsl:template>
<xsl:template match="*" mode="globalvaluepairs"/>

<xsl:template match="cbc:PaymentAlternativeCurrencyCode[.!='']|cbc:PaymentCurrencyCode[.!=''] | cbc:PricingCurrencyCode[.!=''] |cbc:TaxCurrencyCode[.!=''] |cbc:DocumentCurrencyCode[.!=''] | cbc:UUID[.!=''] | cbc:ID[.!=''] | cbc:ProfileID[.!=''] | cbc:CustomizationID[.!=''] | cbc:UBLVersionID[.!='']" mode="globalvaluepairs">
<xsl:variable name="localname" select="local-name()"/>
<xsl:value-of select="$moduleDoc/module/document-merge/g-funcs/g[@name=$localname]"/>&#160;<xsl:value-of select="."/>
							<br/>
</xsl:template>
	
</xsl:stylesheet>
