/**
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.common.cache;

/**
 * Dummy cache. Caches nothing.
 * 
 * Always returns false - when checking for precense. Always returns null -
 * trying to retrieve objedt.
 */
public class TimedNullCache implements ITimedCache {

    /**
     * Do nothing.
     * @param key
     *            key for cached item
     * @param value
     *            item to cache
     */            
    public final void add(final Object key, final Object value) {
        // Do nothing.
    }

    /**
     * Always return false.
     * @param key
     *            key to search for
     * @return false always
     */
    public final boolean containsKey(final Object key) {
        // Do nothing.
        return false;
    }

    /**
     * Do nothing.
     * @param key
     *            remove item for key
     */
    public final void remove(final Object key) {
        // Do nothing.
    }

    /**
     * Always return null.
     * @param key
     *            search for item with key
     * @return always null
     */
    public final Object tryGetValue(final Object key) {
        // Do nothing.
        return null;
    }

}
