/**
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.uddi.ars;

import dk.gov.oiosi.common.ValUtil;
import dk.gov.oiosi.uddi.IRegistrationEntity;
import dk.gov.oiosi.uddi.UddiGuidId;
import dk.gov.oiosi.uddi.UddiId;
import dk.gov.oiosi.uddi.category.ArsCategory;
import dk.gov.oiosi.uddi.category.EndpointAddressType;
import dk.gov.oiosi.uddi.category.UddiOrgWsdlCategorizationTransportCode;
import dk.itst.uddi.client.types.core.AccessPoint;
import dk.itst.uddi.client.types.core.BindingTemplate;
import dk.itst.uddi.client.types.core.Description;

/** 
 * Represents an ARS-profiled UDDI bindingTemplate
 * 
 */
public class ArsBinding extends RegistrationEntity implements IRegistrationEntity {

    private BindingTemplate _bindingTemplate = null;

    /** 
     * Returns the underlying BindingTemplate object
     * 
     */
    public BindingTemplate getBindingTemplate() {
        return _bindingTemplate; 
    }

    /** 
     * Gets or sets the endpoint address type
     * 
     */
    public EndpointAddressType getAddressType() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - getAddressType - TODO Implement" );
        return null;
        
//        if (_bindingTemplate != null && _bindingTemplate.CategoryBag != null) {
//            EndpointAddressType endpointAddressType = new EndpointAddressType();
//            return (EndpointAddressType)GetCategory(endpointAddressType);
//        } else {
//            return null;
//        }
    }
    public void setAddressType(EndpointAddressType value) {
        if( true ) throw new NoSuchMethodError( "ArsBinding - setAddressType - TODO Implement" );
//        if (value != null) {
//            if (_bindingTemplate.CategoryBag == null) {
//                _bindingTemplate.CategoryBag = new CategoryBag(value.GetAsKeyedReference());
//            } else {
//                _bindingTemplate.CategoryBag.SetCategory(value.GetAsKeyedReference());
//            }
//        } else {
//            if (_bindingTemplate.CategoryBag != null) {
//                _bindingTemplate.CategoryBag.RemoveCategoryById(new EndpointAddressType().CategoryID);
//            }
//        }
    }

    ArsProcessInstanceSet _instanceSet = null;

    /** 
     * Gets or sets the process instance set
     * 
     */
    public void setProcessInstanceSet(ArsProcessInstanceSet value) {
        if( true ) throw new NoSuchMethodError( "ArsBinding - setProcessInstanceSet - TODO Implement" );
//        if (value != null) {
//            if (value.Processes.Count > 0) {
//                foreach (ArsProcessInstance instance in value.Processes) {
//                    _bindingTemplate.AddTModelInstanceInfo(instance.InstanceInfo);
//                }
//            }
//        }
    }
    public ArsProcessInstanceSet getProcessInstanceSet() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - getProcessInstanceSet - TODO Implement" );
        else return null;
        
//        if (_instanceSet != null) return _instanceSet;
//                
//        _instanceSet = new ArsProcessInstanceSet();
//        
//        if (_bindingTemplate.TModelInstanceInfos != null)
//        {
//            foreach (TModelInstanceInfo instanceInfo in _bindingTemplate.TModelInstanceInfos)
//            {
//                Inquiry inq = new Inquiry();
//                get_tModelDetail tModelDetail = new get_tModelDetail();
//                tModelDetail.tModelKey = new string[1];
//                tModelDetail.tModelKey[0] = instanceInfo.Value.tModelKey;
//                TModel[] models = inq.GetDetail(tModelDetail);
//                if (models.Length > 0)
//                {
//                    CategoryBag bag = models[0].CategoryBag;
//                    KeyedReference regConfClaim = null;
//                    KeyedReference processRoleIdentifierType = null;
//                    KeyedReference processDefinitionReference = null;
//                    if (bag != null)
//                    {
//                        regConfClaim = bag.GetCategoryByName(new RegistrationConformanceClaim().CategoryName);
//                        processRoleIdentifierType = bag.GetCategoryByName(new BusinessProcessRoleIdentifierType().CategoryName);
//                        processDefinitionReference = bag.GetCategoryByName(new BusinessProcessDefinitionReference().CategoryName);
//                    }
//                    if (regConfClaim != null && processRoleIdentifierType != null && 
//                            processDefinitionReference != null)
//                    {
//                        RegistrationConformanceClaim conformanceClaimInstance =
//                            new RegistrationConformanceClaim();
//                        if (regConfClaim.KeyValue == conformanceClaimInstance.DefaultCategoryValue)
//                        {
//                            _instanceSet.Add(new ArsProcessInstance(models[0]));
//                        }
//                    }
//                }
//            }
//        }
//        return _instanceSet;
    }

    /** 
     * Removes the underlying tModel info 
     * 
     * @param  instance 
     * @return 
     */ 
    public boolean removeProcessInstance(ArsProcessInstance instance) {
        if( true ) throw new NoSuchMethodError( "ArsBinding - setProcessInstanceSet - TODO Implement" );

//        if (_bindingTemplate.TModelInstanceInfos != null) {
//            for (int iInstanceInfo = 0; iInstanceInfo < _bindingTemplate.TModelInstanceInfos.Length; iInstanceInfo++) {
//                TModelInstanceInfo instanceInfo = _bindingTemplate.TModelInstanceInfos[iInstanceInfo];
//                if (IdentifierUtility.GetUddiIDFromString(instanceInfo.Value.tModelKey).ID == instance.ID.ID) {
//                    TModelInstanceInfo[] temp = new TModelInstanceInfo[_bindingTemplate.TModelInstanceInfos.Length - 1];
//                    int iNew = 0;
//                    for (int iTemp = 0; iTemp < _bindingTemplate.TModelInstanceInfos.Length; iTemp++) {
//                        if (iTemp != iInstanceInfo) {
//                            temp[iNew] = _bindingTemplate.TModelInstanceInfos[iTemp];
//                            iNew++;
//                        }
//                    }
//                    _bindingTemplate.TModelInstanceInfos = temp;
//                    
//                    return true;
//                }
//            }
//        }
        return false;
    }

    OasisServiceSingleBindingRegistration _serviceRegistration = null;

    /** 
     * Gets or sets the service regsistration reference
     * 
     */
    public OasisServiceSingleBindingRegistration getServiceRegistration() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - getServiceRegistration - TODO Implement" );
        else return null;

//        if (_serviceRegistration != null) return _serviceRegistration;
//        OasisPortTypeRegistrationReference portTypeRef = new OasisPortTypeRegistrationReference();
//        OasisBindingRegistrationReference bindingRef = new OasisBindingRegistrationReference();
//        _serviceRegistration = new OasisServiceSingleBindingRegistration();
//
//        if (_bindingTemplate.TModelInstanceInfos != null)
//        {
//            foreach (TModelInstanceInfo instanceInfo in _bindingTemplate.TModelInstanceInfos)
//            {
//                Inquiry inq = new Inquiry();
//                get_tModelDetail tModelDetail = new get_tModelDetail();
//                tModelDetail.tModelKey = new string[1];
//                tModelDetail.tModelKey[0] = instanceInfo.Value.tModelKey;
//                TModel[] models = inq.GetDetail(tModelDetail);
//                if (models.Length > 0)
//                {
//                    CategoryBag bag = models[0].CategoryBag;
//                    KeyedReference regConfClaim = null;
//                    KeyedReference wsdlTypes = null;
//                    if (bag != null)
//                    {
//                        regConfClaim = bag.GetCategoryByName(new RegistrationConformanceClaim().CategoryName);
//                        wsdlTypes = bag.GetCategoryByName(new UddiOrgWsdlTypes().CategoryName);
//                    }
//                    if (regConfClaim != null && wsdlTypes != null)
//                    {
//                        RegistrationConformanceClaim conformanceClaimInstance =
//                            new RegistrationConformanceClaim();
//                        if (regConfClaim.KeyValue == conformanceClaimInstance.DefaultCategoryValue)
//                        {
//                            if (wsdlTypes.KeyValue == "binding")
//                            {
//                                bindingRef = new OasisBindingRegistrationReference(instanceInfo);
//                                _serviceRegistration.BindingRegistrationRef = bindingRef;
//                            }
//                            else if (wsdlTypes.KeyValue == "portType")
//                            {
//                                portTypeRef = new OasisPortTypeRegistrationReference(new UddiGuidId(instanceInfo.Value.tModelKey, true));
//                                _serviceRegistration.PortTypeRegistrationRef = portTypeRef;
//                            }
//                        }
//                    }
//                }
//            }
//            
//        }
//        
//        return _serviceRegistration;
    }
    
    public void setServiceRegistration(OasisServiceSingleBindingRegistration value) {
        if( true ) throw new NoSuchMethodError( "ArsBinding - setServiceRegistration - TODO Implement" );

//        if (value == null) {
//            return;
//        }
//        
//        try {
//            //1. Add all porttype registration references
//            if (value.PortTypeRegistrationRef != null) {
//                _bindingTemplate.AddTModelInstanceInfo(value.PortTypeRegistrationRef.PortTypeReference);
//            }
//            
//            //2. Add all binding registration references
//            if (value.BindingRegistrationRef != null ) {
//                _bindingTemplate.AddTModelInstanceInfo(value.BindingRegistrationRef.BindingReference);
//            }
//            
//            //2. Add all binding registration references
//            /*if (value.SmtpBindingRegistrationRef != null) {
//                        _bindingTemplate.AddTModelInstanceInfo(value.SmtpBindingRegistrationRef.BindingReference);
//                    }*/     
//        } catch (Exception e) {
//            throw new ArsBindingUnexpectedException(e);
//        }
    }


    /** 
     * Gets or sets the access point
     * 
     */
    public AccessPoint getAccessPoint() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - getAccessPoint - TODO Implement" );
        else return null;
//        if (_bindingTemplate.getAccessPoint() != null) {
//            AccessPoint ap = AccessPoint.Factory.newInstance(); // (); // _bindingTemplate.getAccessPoint()..Value);
//            return ap;
//        }
//        else {
//            return null;
//        }
        
    }
    public void setAccessPoint (AccessPoint value) throws ArsException{
        try {
            if (value != null) {
                _bindingTemplate.setAccessPoint( value );
            } else {
                _bindingTemplate.setAccessPoint(null);
            }
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }

    /** 
     * Gets or sets the description. Returns null if no description exists
     * 
     */
    public Description getDescription() {
        if (_bindingTemplate != null){
            return _bindingTemplate.getDescriptionArray(0);
        } else {
            return null;
        }
    }
    public void setDescription (Description value){
        _bindingTemplate.setDescriptionArray( new Description[] { value } );
    }
 
    /** 
     * Gets or sets the service key
     * 
     */
    public UddiId getServiceKey() {
        if (_bindingTemplate != null && _bindingTemplate.getServiceKey()!= null && _bindingTemplate.getServiceKey().length() > 0)
            return new UddiGuidId(_bindingTemplate.getServiceKey(), true);
        else {
            return null;
        }
    }
    public void setServiceKey(UddiId value) throws ArsException {
        try {
            if (_bindingTemplate != null) {
                if (value == null) {
                    _bindingTemplate.setServiceKey( "" );
                } else {
                    _bindingTemplate.setServiceKey(value.getID());
                }
            }
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }


    /** 
     * Gets or sets the binding key. Ignored if set with null
     * 
     */
    public UddiId getBindingKey() {
        if (_bindingTemplate != null && _bindingTemplate.getBindingKey() != null && !ValUtil.isNullOrEmpty(_bindingTemplate.getBindingKey())) {
            return new UddiGuidId(_bindingTemplate.getBindingKey(), true);
        }  else {
            return null;
        }
    }
    public void setBindingKey(UddiId value) throws ArsException {
        try {
            if (_bindingTemplate != null && _bindingTemplate.getBindingKey() != null) {
                if (value == null) {
                    _bindingTemplate.setBindingKey("");
                } else {
                    _bindingTemplate.setBindingKey(value.getID());
                }
            }
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }


    /** 
     * Gets the uuid of the binding
     * 
     */
    public UddiId getID() {
        if (_bindingTemplate != null && _bindingTemplate.getBindingKey() != null && _bindingTemplate.getBindingKey().length() > 0)
            return new UddiGuidId(_bindingTemplate.getBindingKey(), true);
        else {
            return null;
        }
    }
    public void setID(UddiId value) throws ArsException {
        try {
            if (_bindingTemplate != null && _bindingTemplate.getBindingKey() != null) {
                if (value == null) {
                    _bindingTemplate.setBindingKey(""); 
                } else {
                    _bindingTemplate.setBindingKey(value.getID());
                }
            }
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }

    /** 
     * Default constructor
     * @throws ArsException 
     * 
     */
    public ArsBinding() throws ArsException {
        try {
            _bindingTemplate = BindingTemplate.Factory.newInstance();
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }
        

    /** 
     * Initialize an existing arsbinding
     * 
     * @param  bindingTemplate the existing arsbinding
     */ 
    public ArsBinding(BindingTemplate bindingTemplate) {
        //1. set the bindingtemplate
        _bindingTemplate = bindingTemplate;
        
        /* We don't set ArsProcessInstanceSet and OasisServiceRegistration 
         * in the release
    
            //2. check that the bindingtemplate is actually a arsbinding template
            if (_bindingTemplate.TModelInstanceInfos.Length == 3) {

                for (int i = 0; i < _bindingTemplate.TModelInstanceInfos.Length; i++) {

                    if (_bindingTemplate.TModelInstanceInfos[i].
                }
            }
            else {
                throw new ArgumentException("the bindingtemplate doesn't comply with the Ars profile");
            }
         * */
    }

    /**
     * Constructor initliazing existing instanceset and serviceregistration
     *
     *@param  instanceSet Set of ARS process instances
     *@param  serviceRegistration Reference to the service definition
     *@param  accessPoint Access point of the endpoint
     *@param  endpointAddressType The type of the accessPoint (e.g. http or email)
     *@param  description The description of the endpoint binding
     *@param  businessServiceKey businessService key
     *@param  bindingKey The binding key - null if none exists
     * @throws ArsException 
     */ 
    public ArsBinding(
            ArsProcessInstanceSet instanceSet,
            OasisServiceSingleBindingRegistration serviceRegistration,
            AccessPoint accessPoint,
            EndpointAddressType endpointAddressType,
            Description description,
            UddiId businessServiceKey,
            UddiId bindingKey) throws ArsException {

        //1. set businessentity attributes, contacts and discoveryUrls
        try {
            setBindingTemplateDetails(instanceSet, serviceRegistration,
                    accessPoint, endpointAddressType, description, businessServiceKey, bindingKey);
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }

    /** 
     * This method sets all bindings
     * 
     * @param  instanceSet Contains a set of process
     * @param  serviceRegistration Reference to porttype and bindings
     * @param  accessPoint The endpoint for the service
     * @param  endpointAddressType The type of the accessPoint (e.g. http or email)
     * @param  description Description of the endpoint binding
     * @param  businessServiceKey The UDDI key of the business service
     * @param  bindingKey The binding key - null if none exists
     * @throws ArsException 
     */ 
    private void setBindingTemplateDetails(
            ArsProcessInstanceSet instanceSet, 
            OasisServiceSingleBindingRegistration serviceRegistration, 
            AccessPoint accessPoint,
            EndpointAddressType endpointAddressType,
            Description description, 
            UddiId businessServiceKey,
            UddiId bindingKey) throws ArsException {

        //1. Set properties:
        try {
            _bindingTemplate = BindingTemplate.Factory.newInstance(); //new BindingTemplate();
            //_processInstanceSet = instanceSet;
            setProcessInstanceSet(instanceSet);
            //_serviceRegistration = serviceRegistration;
            setServiceRegistration(serviceRegistration);
            _bindingTemplate.setAccessPoint( accessPoint);
            setAddressType(endpointAddressType);
            setDescription(description);
            setServiceKey(businessServiceKey);
            setBindingKey(bindingKey);
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }

    /** 
     * Gets an ARS category by the category ID of the 'categoryObject' 
     * parameter. Note that we need an actual ArsCategory descendant 
     * object to get the category identifier. If no match is found, null is returned.
     * 
     * @param  category The category object from which to get the category ID.
     * Another object, with key and value set, is returned as a result.
     * @return 
     */
    private ArsCategory getCategory(ArsCategory category) {
        if( true ) throw new NoSuchMethodError( "ArsBinding - getCategory - TODO Implement" );
        else return null;

//        if (category == null) return null;
//        
//        try {
//            CategoryBag bag = new CategoryBag(_bindingTemplate.Value.categoryBag);
//            KeyedReference keyRef = bag.GetCategoryByIdentifier(category.CategoryID);
//            if (keyRef == null) return null;
//            category.SetCategoryValue(keyRef.KeyName, keyRef.KeyValue);
//        } catch (Exception e) {
//            throw new ArsBindingUnexpectedException(e);
//        }
//        return category;
    }

    /** 
     * Method to handle the call to SaveBinding()
     * @throws ArsException 
     * 
     */
    public void save() throws ArsException {

        try {
            //1. Validate
            validate();

            //2. Save the bindingtemplate to the Uddi server
            saveBinding();
        } catch (Exception e) {
            throw new ArsBindingUnexpectedException(e);
        }
    }

    /** 
     * Saves the binding to the Uddi server
     * 
     */
    private void saveBinding() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - saveBinding - TODO Implement" );

//        BindingTemplateCollection templateCollection = new BindingTemplateCollection();
//        templateCollection.Add(_bindingTemplate.Value);
//            
//        try {
//            //1. call Publication
//            Publication uddiPublicationProxy = new Publication(Connection);
//            bindingDetail detail = uddiPublicationProxy.Save(templateCollection);
//            _bindingTemplate = new BindingTemplate(detail.bindingTemplate[0]);
//        } catch (SaveBindingException) {
//            throw;
//        } catch (PublicationUnexpectedException) {
//            throw;
//        } catch (Exception e) {
//            throw new ArsBindingUnexpectedException(e);
//        }
    }

    /** 
     * Performs validation of this entity
     * 
     */ 
    public void validate() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - validate - TODO Implement" );

        String portTypeReferenceOnBinding = "";
        String actualPortTypeReference = "";

//        //1. Validate
//        Inquiry inq = new Inquiry();
//        GetTModelDetail getBindingTModel = new GetTModelDetail(ServiceRegistration.BindingRegistrationRef.ID.ID);
//        TModel[] tmodels = inq.GetDetail(getBindingTModel.Value);
//        
//        if (tmodels != null && tmodels.Length > 0) {
//            CategoryBag bag = tmodels[0].CategoryBag;
//            KeyedReference keyref = bag.GetCategoryByName(new UddiOrgWsdlPortTypeReference().CategoryName);
//
//            portTypeReferenceOnBinding = keyref.KeyValue;
//            actualPortTypeReference = ServiceRegistration.PortTypeRegistrationRef.PortTypeReference.Value.tModelKey;
//        }
//
//        if (portTypeReferenceOnBinding != actualPortTypeReference) {
//            throw new Exception("Validation failed for the binding. Porttype reference in the binding, does not match the actual porttype referenced");
//        }
    }

    /** 
     * Updates this entity
     * 
     */
    public void update() {
            
        //1. Validate
        validate();

        //2. Save
        saveBinding();
    }

    /** 
     * Deletes the bindingtemplate
     * 
     */ 
    public void delete() {
        if( true ) throw new NoSuchMethodError( "ArsBinding - getCategory - TODO Implement" );

//        //1. check that an binding uuid exists
//        if (_bindingTemplate.Value.bindingKey.Length > 0) {
//            
//            String[] temp = new String[1];
//            temp[0] = _bindingTemplate.Value.bindingKey;
//
//            //2. call Publication.Delete
//            try {
//                Publication uddiPublicationProxy = new Publication(Connection);
//                bool deleted = uddiPublicationProxy.DeleteBindingTemplate(temp);
//                if (deleted) {
//                    _bindingTemplate = new BindingTemplate();
//                }
//            } catch (DeleteBindingException) {
//                throw;
//            } catch (PublicationUnexpectedException) {
//                throw;
//            } catch (Exception e) {
//                throw new ArsBindingUnexpectedException(e);
//            }
//        } else {
//            throw new Exception("No bindingkey was found");
//        }
    }

    /** 
     * Validates the embedded data, and eventually returns a structured report if validations fails
     * 
     * @param  EntityName 
     * @param  Failures 
     * @return 
     */
    public boolean isValid(String entityName) { // , ref ValidationFailureCollection Failures) {
        //            ValidationFailureCollection ChildFailures = null;
        //            bool Valid = true;
        //
        //            BindingTemplate.IsValid(_bindingTemplate, "_bindingTemplate", ref ChildFailures);
        //
        //            if (ChildFailures != null) {
        //                ChildValidationFailure.AddFailure(ChildFailure.Message(), EntityName, this.GetType(),
        //                    ChildFailures, ref Failures);
        //                Valid = false;
        //            }
        //
        //            return Valid;
        return _bindingTemplate.validate();
    }

    /** 
     * Finds a binding by porttypereference and transporttype
     * 
     * @return the uuid of the found binding
     */
    public static String findBindingGuid(UddiId porttypeUuid, UddiOrgWsdlCategorizationTransportCode transport) {
        if( true ) throw new NoSuchMethodError( "ArsBinding - findBindingGuid - TODO Implement" );
        else return null;
        
//        Inquiry inq = new Inquiry();
//        CategoryBag bag = new CategoryBag();
//
//        RegistrationConformanceClaim regConClaim =
//            new RegistrationConformanceClaim(RegistrationConformanceClaimCode.oiosi1_1);
//        UddiOrgWsdlCategorizationTransport bindingTransport = new UddiOrgWsdlCategorizationTransport(transport);
//        UddiOrgWsdlTypes type = new UddiOrgWsdlTypes(UddiOrgWsdlTypeCode.binding);
//        UddiOrgWsdlPortTypeReference portTypeReference = new UddiOrgWsdlPortTypeReference(porttypeUuid);
//
//        bag.AddCategory(regConClaim.GetAsKeyedReference());
//        bag.AddCategory(bindingTransport.GetAsKeyedReference());
//        bag.AddCategory(type.GetAsKeyedReference());
//        bag.AddCategory(portTypeReference.GetAsKeyedReference());
//
//        FindTModel findTModel = new FindTModel(bag.GetInnerCollectionAsKeyedReferenceCollection());
//        tModelList list = inq.Find(findTModel);
//
//        if (list.tModelInfos == null) {
//            return null;
//        } else if (list.tModelInfos.Length == 0) {
//            return null;
//        } else if (list.tModelInfos != null && list.tModelInfos.Length == 1) {
//            return list.tModelInfos[0].tModelKey;
//        } else {
//            throw new Exception("There has been an error in the registration process." +
//                    " There exists more than two bindings, on the portype " + porttypeUuid.ID + ".");
//        }
    }

}
