/**
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.uddi.ars;

/**
 * Utility class. Holds methods for queriying an UDDI registry following the ARS
 * profile
 * 
 */
public class ArsDefaultInstances {

    private static String _invoiceBindingSmtpUddiId = "uddi:28982f00-6460-4e65-a0a0-a1a83ae81b69";

    private static String _invoiceBindingSmtpName = "InvoiceBindingSmtp";

    private static String _invoiceBindingHttpUddiId = "uddi:ee073296-bbc8-4d8f-8f27-841c26857d47";

    private static String _invoiceBindingHttpName = "InvoiceBindingHttp";

    private static String _invoicePortTypeUddiId = "uddi:2e0b402a-7a5e-476b-8686-b33f54fd1f47";

    private static String _invoicePortTypeName = "InvoicePortType";

    /**
     * 
     * 
     */
    public static String getInvoiceBindingSmtpUddiId() {
        return ArsDefaultInstances._invoiceBindingSmtpUddiId;
    }

    /**
     * 
     * 
     */
    public static String getInvoiceBindingSmtpName() {
        return ArsDefaultInstances._invoiceBindingSmtpName;
    }

    /**
     * 
     * 
     */
    public static String getInvoiceBindingHttpUddiId() {
        return ArsDefaultInstances._invoiceBindingHttpUddiId;
    }

    /**
     * 
     * 
     */
    public static String getInvoiceBindingHttpName() {
        return ArsDefaultInstances._invoiceBindingHttpName;
    }

    /**
     * 
     * 
     */
    public static String getInvoicePortTypeUddiId() {
        return ArsDefaultInstances._invoicePortTypeUddiId;
    }

    /**
     * 
     * 
     */
    public static String getInvoicePortTypeName() {
        return ArsDefaultInstances._invoicePortTypeName;
    }

    /**
     * Looks through the existing database and creates / updates requiered
     * instances
     * 
     */
    public static void checkDefaultInstances() {
    }

}
