/**
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.uddi.ars;

import dk.gov.oiosi.exception.MainException;

/**
 * Base exception class for ARS exceptions
 * 
 */
public abstract class ArsException extends MainException {

    // private static ResourceManager resourceManager = new
    // ResourceManager(typeof(ErrorMessages));

    /**
     * Base constructor
     * 
     */
    public ArsException() {
        super();
    }

    /**
     * Constructor with keywords
     * 
     * @param message
     *            the message
     */
    public ArsException(String message) {
        super(message);
    }

    /**
     * Constructor with keywords
     * 
     * @param keywords
     *            keywords for the message
     */
    // public ArsException(System.Collections.Generic.Dictionary<string, string>
    // keywords) : base(resourceManager, keywords) { }
    /**
     * Constructor with innerexception
     * 
     * @param innerException
     *            innerexception of the thrown exception
     */
    public ArsException(Exception innerException) {
        super(innerException);
    }
}
