/**
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.uddi.ars;

import java.util.ArrayList;
import java.util.List;


/** 
 * Utility class. Holds methods for queriying an UDDI registry following the ARS
 * profile
 */
public class ArsLookup {

    /** 
     * Gets all businessentities with a given CVR number. 
     * 
     * @param  cvr the cvr to use for lookup
     * @return a list of businessentities List<businessInfo>
     */
    public static List findArsBusinessEntitiesByCvr(String cvr) {

        if( true ) throw new NoSuchMethodError( "ArsLookup - findArsBusinessEntitiesByCvr - TODO Implement" );
        else return null;
        
//        List returnList = new ArrayList();
//
//        try {
//            //1. make a FindBusiness object
//            FindBusiness findBusiness = FindBusiness.Factory.newInstance(); // new FindBusiness();
//
//            //2. create a categorybag with the categories to look for
//            CategoryBag categoryBag = CategoryBag.Factory.newInstance(); // new CategoryBag();
//            CategoryBag identifierBag = CategoryBag.Factory.newInstance(); // new CategoryBag();
//                
//
//            KeyedReference orgKeyType = new OrganizationKeyType().getAsKeyedReference();
//            orgKeyType.setKeyValue( "http://oio.dk/profiles/OWSA/modelT/1.0/UDDI/Identifiers/cvrNumber/" );
//
//            KeyedReference orgKey = new OrganizationKey().getAsKeyedReference();
//            orgKey.setKeyValue(cvr);
//
//            categoryBag.AddCategory(new RegistrationConformanceClaim(new RegistrationConformanceClaimCode(RegistrationConformanceClaimCode.oiosi1_1)).getAsKeyedReference());
//            categoryBag.AddCategory(orgKeyType);
//            identifierBag.AddCategory(orgKey);
//
//            findBusiness.Value.categoryBag = categoryBag.Value;
//            findBusiness.Value.identifierBag = identifierBag.GetInnerCollectionAsKeyedReferenceCollection().GetKeyedReferenceCollection();
//
//            //3. call Find method in SDK
//            Inquiry inq = new Inquiry();
//            businessList list = inq.Find(findBusiness);
//
//            if (list.businessInfos != null)
//                for (int k = 0; k < list.businessInfos.Length; k++) {
//                    returnList.Add(list.businessInfos[k]);
//                }
//        } catch (Exception exp) {
//            throw new ArsLookupUnexpectedException(exp);
//        }
//        return returnList;
    }

    /** 
     * Gets all businessentities with a given name. Wildcard "%" can be used.
     * 
     * @param  name the name to use for lookup
     * @return a list of businessentities List<businessInfo>
     */
    public static List findArsBusinessEntities(String name) {

        if( true ) throw new NoSuchMethodError( "ArsLookup - findArsBusinessEntities - TODO Implement" );
        else return null;

//        // List<businessInfo> returnList = new List<businessInfo>();
//        List returnList = new ArrayList();
//
//        try {
//            //1. make a FindBusiness object with the name to lookup
//            FindBusiness findBusiness = FindBusiness.Factory.newInstance(); //new FindBusiness(name);
//
//            //2. create a categorybag with the categories to look for
//            CategoryBag catbag = new CategoryBag();
//
//            KeyedReference keyedref = new OrganizationKeyType().GetAsKeyedReference();
//            keyedref.KeyValue = "%";
//
//            catbag.AddCategory(new RegistrationConformanceClaim(RegistrationConformanceClaimCode.oiosi1_1).GetAsKeyedReference());
//            catbag.AddCategory(keyedref);
//
//            findBusiness.Value.categoryBag = catbag.Value;
//
//            //3. call Find method in SDK
//            Inquiry inq = new Inquiry();
//            businessList list = inq.Find(findBusiness);
//
//            if (list.businessInfos!=null) {
//                for (int k = 0; k < list.businessInfos.Length; k++)
//                {
//                    returnList.Add(list.businessInfos[k]);
//                }
//            }
//        } catch (Exception exp) {
//            throw new ArsLookupUnexpectedException(exp);
//        }
//        return returnList;
    }


    //private static List<tModelInfo> LookupArsServiceDefinition(string name, string transport) {
    private static List lookupArsServiceDefinition(String name, String transport) {

        if( true ) throw new NoSuchMethodError( "ArsLookup - lookupArsServiceDefinition - TODO Implement" );
        else return null;

//        List returnList = new ArrayList();
//
//        try {
//            //1. make a FindTModel object with the name to lookup
//            FindTModel findTModel = new FindTModel(name);
//
//            //2. create a categorybag with the categories to look for
//            CategoryBag catbag = new CategoryBag();
//
//            KeyedReference uddiOrgXmlNS = new UddiOrgXmlNamespace().getAsKeyedReference();
//            uddiOrgXmlNS.KeyValue = "%";
//
//            UddiOrgWsdlTypes uddiOrgWsdlTypes = new UddiOrgWsdlTypes(UddiOrgWsdlTypeCode.binding);
//
//            KeyedReference uddiOrgWsdlPortType = new UddiOrgWsdlPortTypeReference().getAsKeyedReference();
//            uddiOrgWsdlPortType.KeyValue = "%";
//
//            KeyedReference uddiOrgWsdlCategorizationProtocol = new UddiOrgWsdlCategorizationProtocol().getAsKeyedReference();
//            uddiOrgWsdlCategorizationProtocol.KeyValue = "%";
//
//            KeyedReference uddiOrgWsdlCategorizationTransport = null;
//            if (transport.Length > 0) {
//                UddiOrgWsdlCategorizationTransportCode transportcode = (UddiOrgWsdlCategorizationTransportCode)Enum.Parse(typeof(UddiOrgWsdlCategorizationTransportCode), transport);
//                switch (transportcode) {
//                case UddiOrgWsdlCategorizationTransportCode.http:
//                    uddiOrgWsdlCategorizationTransport = new UddiOrgWsdlCategorizationTransport(UddiOrgWsdlCategorizationTransportCode.http).getAsKeyedReference();
//                    break;
//                case UddiOrgWsdlCategorizationTransportCode.smtp:
//                    uddiOrgWsdlCategorizationTransport = new UddiOrgWsdlCategorizationTransport(UddiOrgWsdlCategorizationTransportCode.smtp).getAsKeyedReference();
//                    break;
//                default:
//                    break;
//                }
//            } else {
//                uddiOrgWsdlCategorizationTransport = new UddiOrgWsdlCategorizationProtocol().getAsKeyedReference();
//                uddiOrgWsdlCategorizationTransport.KeyValue = "%";
//            }
//                
//            UddiOrgTypes uddiOrgTypes = new UddiOrgTypes(UddiOrgTypesCode.wsdlSpec);
//
//            catbag.AddCategory(new RegistrationConformanceClaim(RegistrationConformanceClaimCode.oiosi1_1).getAsKeyedReference());
//            catbag.AddCategory(uddiOrgXmlNS);
//            catbag.AddCategory(uddiOrgWsdlTypes.GetAsKeyedReference());
//            catbag.AddCategory(uddiOrgWsdlPortType);
//            catbag.AddCategory(uddiOrgWsdlCategorizationProtocol);
//            catbag.AddCategory(uddiOrgWsdlCategorizationTransport);
//            catbag.AddCategory(uddiOrgTypes.GetAsKeyedReference());
//
//            findTModel.CategoryBag = catbag.Value;
//
//            //3. call Find method in SDK
//            Inquiry inq = new Inquiry();
//            tModelList list = inq.Find(findTModel);
//            
//            if (list.tModelInfos != null) {
//                for (int k = 0; k < list.tModelInfos.Length; k++) {
//                    returnList.Add(list.tModelInfos[k]);
//                }
//            }
//        } catch (Exception exp) {
//            throw new ArsLookupUnexpectedException(exp);
//        }
//        return returnList;
    }


    /** 
     * Gets all central service definition (binding) tmodels. Wildcard "%" can be used.
     * 
     * @param  name the name to use for lookup
     * @param  transport the transport parameter used in the lookup
     * @return a list of tmodels List<tModelInfo>
     * @throws ArsException 
     */
    public static List findArsServiceDefinition(String name, String transport) throws ArsException {

        List returnList = new ArrayList();

        try {
            returnList = lookupArsServiceDefinition(name, transport);
        } catch (Exception exp) {
            throw new ArsLookupUnexpectedException(exp);
        }
        return returnList;
    }

    /** 
     * Gets all central service definition (binding) tmodels. Wildcard "%" can be used.
     * 
     * @param  name the name to use for lookup
     * @return a list of tmodels List<tModelInfo>
     * @throws ArsException 
     */
    public static List findArsServiceDefinition(String name) throws ArsException {

        List returnList = new ArrayList();

        try {
            returnList = lookupArsServiceDefinition(name, "");
        } catch (Exception exp) {
            throw new ArsLookupUnexpectedException(exp);
        }
        return returnList;
    }

    /** 
     * Gets all central service definition (binding) tmodels. Wildcard "%" can be used.
     * 
     * @param  name the name to use for lookup
     * @return a list of tmodels List<tModelInfo>
     */
    public static List findArsServiceDefinitionByPortType(String name) {

        if( true ) throw new NoSuchMethodError( "ArsLookup - findArsServiceDefinitionByPortType - TODO Implement" );
        else return null;

//        List returnList = new ArrayList();
//
//        try {
//            //1. make a FindTModel object with the name to lookup
//            FindTModel findTModel = new FindTModel(name);
//
//            //2. create a categorybag with the categories to look for
//            CategoryBag catbag = new CategoryBag();
//
//            UddiOrgWsdlTypes uddiOrgWsdlTypes = new UddiOrgWsdlTypes(UddiOrgWsdlTypeCode.portType);
//
//            catbag.AddCategory(new RegistrationConformanceClaim(RegistrationConformanceClaimCode.oiosi1_1).GetAsKeyedReference());
//            catbag.AddCategory(uddiOrgWsdlTypes.GetAsKeyedReference());
//
//            findTModel.CategoryBag = catbag.Value;
//
//            //3. call Find method in SDK
//            Inquiry inq = new Inquiry();
//            tModelList list = inq.Find(findTModel);
//
//            if (list.tModelInfos != null) {
//                for (int k = 0; k < list.tModelInfos.Length; k++) {
//                    returnList.Add(list.tModelInfos[k]);
//                }
//            }
//        } catch (Exception exp) {
//            throw new ArsLookupUnexpectedException(exp);
//        }
//        return returnList;
    }

    /** 
     * Gets all business process definition tmodels. Wildcard "%" can be used.
     * 
     * @param  name the name to use for lookup
     * @return a list of tmodels List<tModelInfo>
     */ 
    public static List findArsProcessDefinition(String name) {

        if( true ) throw new NoSuchMethodError( "ArsLookup - findArsProcessDefinition - TODO Implement" );
        else return null;
        
//        List returnList = new ArrayList();
//        try {
//            //1. make a FindTModel object with the name to lookup
//            FindTModel findTModel = new FindTModel(name);
//
//            //2. create a categorybag with the categories to look for
//            CategoryBag catbag = new CategoryBag();
//            KeyedReferenceCollection identifierBag = new KeyedReferenceCollection();
//
//            //KeyedReference keyedref = new BusinessProcessIdentifierType().GetAsKeyedReference();
//            KeyedReference keyedref = new BusinessProcessDocument().GetAsKeyedReference();
//            keyedref.KeyValue = "%";
//
//            catbag.AddCategory(new RegistrationConformanceClaim(RegistrationConformanceClaimCode.oiosi1_1).getAsKeyedReference());
//
//            identifierBag.Add(keyedref);
//            //catbag.AddCategory(keyedref);
//
//            findTModel.CategoryBag = catbag.Value;
//            findTModel.IdentifierBag = identifierBag.GetKeyedReferenceCollection();
//
//            //3. call Find method in SDK
//            Inquiry inq = new Inquiry();
//            tModelList list = inq.Find(findTModel);
//
//            if (list.tModelInfos!=null) {
//                for (int k = 0; k < list.tModelInfos.Length; k++) {
//                    returnList.Add(list.tModelInfos[k]);
//                }
//            }
//        } catch (Exception exp) {
//            throw new ArsLookupUnexpectedException(exp);
//        }
//        return returnList;
    }

    /** 
     * Gets all business process instance tmodels. Wildcard "%" can be used.
     * 
     * @param  name the name to use for lookup
     * @return a list of tmodels List<tModelInfo>
     */ 
    public static List findArsProcessInstance(String name) {

        if( true ) throw new NoSuchMethodError( "ArsLookup - findArsProcessInstance - TODO Implement" );
        else return null;

//        List returnList = new ArrayList();
//
//        try {
//            //1. make a FindTModel object with the name to lookup
//            FindTModel findTModel = new FindTModel(name);
//
//            //2. create a categorybag with the categories to look for
//            CategoryBag catbag = new CategoryBag();
//
//            KeyedReference keyedref = new BusinessProcessDefinitionReference().GetAsKeyedReference();
//            keyedref.KeyValue = "%";
//
//            catbag.AddCategory(new RegistrationConformanceClaim(RegistrationConformanceClaimCode.oiosi1_1).GetAsKeyedReference());
//            catbag.AddCategory(keyedref);
//
//            findTModel.CategoryBag = catbag.Value;
//            
//            //2. call Find method in SDK
//            Inquiry inq = new Inquiry();
//            tModelList list = inq.Find(findTModel);
//
//            if (list.tModelInfos!=null) {
//                for (int k = 0; k < list.tModelInfos.Length; k++) {
//                    returnList.Add(list.tModelInfos[k]);
//                }
//            }
//        } catch (Exception exp) {
//            throw new ArsLookupUnexpectedException(exp);
//        }
//        return returnList;
    }

}
