/**
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.xml;

import dk.gov.oiosi.exception.NullOrEmptyArgumentException;

/**
 * Wrap the Java STD. w3 and Axis Axiom document representation.
 */
public class XmlSchema extends XmlDocument {

    /**
     * Constructor.
     * 
     * @param file
     *            name of schema file
     */
    public XmlSchema(String file) {
        if(file==null||file.trim().length()==0) {
            throw new NullOrEmptyArgumentException("Xml schema file name");
        }
        fileName = file;
    }

    /**
     * Return name of schema file.
     * 
     * @return name of schema file
     */
    public String getFileName() {
        return fileName;
    }

}
