/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this
 * file except in compliance with the License. You may obtain
 * a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 *
 * The Original Code is Java RASP toolkit.
 *
 * The Initial Developer of the Original Code is Lenio. Portions
 * created by Lenio are Copyright (C) 2007 Danish National IT and 
 * Telecom Agency (http://www.itst.dk). All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Dejbjerg Pedersen (tdp@lenio.dk)
 *   Hans Guldager Knudsen, Lenio
 *   Patrik Johansson (p.johansson@accenture.com)
 *   Dennis Sgaard (dennis.j.sogaard@accenture.com)
 *   Mikkel Hippe Brun (mhb@itst.dk)
 *   Finn Hartmann Jordal (fhj@itst.dk)
 *   Christian Lanng (chl@itst.dk).
 *
 */

package dk.gov.oiosi.test;

/**
 * Constatns for testing.
 */
public class TestConstants {

    public static final String PATH_APPLICATIONRESPONSE_XML = "test/Xml/OIOUBL_ApplicationResponse_v2p1.xml";

    public static final String PATH_CREDITNOTE_XML = "test/Xml/OIOUBL_CreditNote_v2p1.xml";

    public static final String PATH_CREDITNOTE07_XML = "test/Xml/OIOXML_CreditNote_v0.7.xml";

    public static final String PATH_INVOICE_XML = "test/Xml/OIOUBL_Invoice_v2p1.xml";

    public static final String PATH_INVOICE07_XML = "test/Xml/OIOXML_Invoice_v0.7.xml";

    public static final String PATH_INVOICEWRONGELEMENT_XML = "test/Xml/OIOUBL_Invoice_v2p1_WrongElement.xml";

    public static final String PATH_INVOICEWRONGNAMESPACE_XML = "test/Xml/OIOUBL_Invoice_v2p1_WrongNamespace.xml";

    public static final String PATH_INVOICENOID_XML = "test/Xml/OIOUBL_Invoice_v2p1_NoId.xml";

    public static final String PATH_INVOICEN7INVALIDEANNUMBER_XML = "test/Xml/OIOXML_Invoice_Invalid_EanNumber_v0.7.xml";

    public static final String PATH_ORDER_XML = "test/Xml/OIOUBL_Order_v2p1.xml";

    public static final String PATH_ORDERRESPONSESIMPLE_XML = "test/Xml/OIOUBL_OrderResponseSimple_v2p1.xml";

    public static final String PATH_REMINDER_XML = "test/Xml/OIOUBL_Reminder_v2p1.xml";

    public static final String PATH_UNKNOWNTYPE_XML = "test/Xml/UnknownType.xml";

    public static final String PATH_APPLICATIONRESPONSE_XSD = "resources/Schemas/OIOUBL v2.01/UBL-ApplicationResponse-2.0.xsd";

    public static final String PATH_CREDITNOTE_XSD = "resources/Schemas/OIOUBL v2.01/UBL-CreditNote-2.0.xsd";

    public static final String PATH_INVOICE_XSD = "resources/Schemas/OIOUBL v2.01/UBL-Invoice-2.0.xsd";

    public static final String PATH_INVOICE07_XSD = "resources/Schemas/OIOXML v0.7/pieStrict.xsd";

    public static final String PATH_NOTIFICATION_XSD = "resources/Schemas/OIOUBL v2.01/Notification.xsd";

    public static final String PATH_ORDER_XSD = "resources/Schemas/OIOUBL v2.01/UBL-Order-2.0.xsd";

    public static final String PATH_ORDERRESPONSESIMPLE_XSD = "resources/Schemas/OIOUBL v2.01/UBL-OrderResponseSimple-2.0.xsd";

    public static final String PATH_REMINDER_XSD = "resources/Schemas/OIOUBL v2.01/UBL-Reminder-2.0.xsd";

    public static final String PATH_APPLICATIONRESPONSE_XSL = "resources/SchematronStylesheets/OIOUBL v2.01/OIOUBL_ApplicationResponse_Schematron.xsl";

    public static final String PATH_CREDITNOTE_XSL = "resources/SchematronStylesheets/OIOUBL v2.01/OIOUBL_CreditNote_Schematron.xsl";

    public static final String PATH_INVOICE_XSL = "resources/SchematronStylesheets/OIOUBL v2.01/OIOUBL_Invoice_Schematron.xsl";

    public static final String PATH_INVOICE07_XSL = "resources/SchematronStylesheets/OIOUBL v0.7/ublinvoice.xsl";

    public static final String PATH_ORDER_XSL = "resources/SchematronStylesheets/OIOUBL v2.01/OIOUBL_Order_Schematron.xsl";

    public static final String PATH_ORDERRESPONSESIMPLE_XSL = "resources/SchematronStylesheets/OIOUBL v2.01/OIOUBL_OrderResponseSimple_Schematron.xsl";

    public static final String PATH_REMINDER_XSL = "resources/SchematronStylesheets/OIOUBL v2.01/OIOUBL_Reminder_Schematron.xsl";

    public static final String PATH_SCHEMAS201 = "resources/Schemas/OIOUBL v2.01/";

    public static final String PATH_SCHEMAS07 = "resources/Schemas/OIOUBL v0.7/";

    public static final String PATH_CERTIFICATE_ORGANISATION = "test/Certificates/virksomhed.cer";

    public static final String PATH_CERTIFICATE_PERSON = "test/Certificates/person.cer";

    public static final String PATH_CERTIFICATE_EMPLOYEE = "test/Certificates/medarbejder.cer";

    public static final String PATH_CERTIFICATE_DEVICE = "test/Certificates/device.cer";

    public static final String PATH_CERTIFICATE_DEVICE_TEST = "test/Certificates/device_test.cer";

    public static final String PATH_CERTIFICATE_ROOT = "test/Certificates/oces_test_root.cer";

    public static final String ITST_CERTIFICATE_SUBJECT = "CN=NemHandel Test 2 + SERIALNUMBER=CVR:26769388-DID:00000002, O=IT- og Telestyrelsen // CVR:26769388, C=DK";
}
