package dk.gov.oiosi.test.stubs;

import java.security.cert.X509Certificate;
import java.util.Date;

import dk.gov.oiosi.configuration.RaspConfigurationHandler;
import dk.gov.oiosi.exception.ArgumentNullException;
import dk.gov.oiosi.security.ocsp.IOcspLookup;
import dk.gov.oiosi.security.ocsp.OcspConfig;
import dk.gov.oiosi.security.ocsp.OcspException;
import dk.gov.oiosi.security.ocsp.OcspResponse;

public class OcspLookupStub implements IOcspLookup {

	public OcspResponse checkCertificate(X509Certificate certificate)
			throws OcspException {
	
		if(certificate == null) throw new ArgumentNullException("certificate");
		OcspResponse result = new OcspResponse();
		result.setIsValid(RaspConfigurationHandler.getInstance().getOcspTestConfig());
		result.setNextUpdate(new Date(3000, 1, 1));
		return result;
	}

	public OcspConfig getConfiguration() {
		return RaspConfigurationHandler.getInstance().getOcspConfig();
	}

}
