package dk.gov.oiosi.test.stubs;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;


import dk.gov.oiosi.configuration.RaspConfigurationHandler;
import dk.gov.oiosi.exception.ArgumentNullException;
import dk.gov.oiosi.exception.MainException;
import dk.gov.oiosi.uddi.IUddiLookupClient;
import dk.gov.oiosi.uddi.LookupParameters;
import dk.gov.oiosi.uddi.UddiLookupResponse;


/**
 * Dummy implementation of the UDDI lookup class, that 
 *
 */
public class UddiLookupClientStub implements IUddiLookupClient  {

	public List lookup(LookupParameters parameters) throws MainException {
		if(parameters == null) throw new ArgumentNullException("parameters");
		
		List result = new ArrayList();
		UddiLookupResponse testResponse;
		try {
			testResponse = RaspConfigurationHandler.getInstance().getUddiClientTestConfig();
		} catch (ParseException e) {
			throw new MainException(e);
		}
		result.add(testResponse);
		return result;
	}

}
